## ismrmrd 1.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
foreach(p
    CMP0025 # CMake 3.0 Compiler id for Apple Clang is now ``AppleClang``.
    CMP0042 # CMake 3.0 ``MACOSX_RPATH`` is enabled by default.
    CMP0046 # CMake 3.0 Error on non-existent dependency in add_dependencies.
    CMP0054 # CMake 3.1 Only interpret ``if()`` arguments as variables or keywords when unquoted.
    CMP0056 # CMake 3.2 Honor link flags in ``try_compile()`` source-file signature.
    CMP0058 # CMake 3.3 Ninja requires custom command byproducts to be explicit.
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()
project(ISMRMRD)

# set project specific cmake module path
set (ISMRMRD_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
  "Location of CMake scripts")

# command line options
option(USE_SYSTEM_PUGIXML "Use pugixml installed on the system" OFF)
option(USE_HDF5_DATASET_SUPPORT "Compile with support for reading and writing datasets to HDF5 files" ON)
option(BUILD_TESTS "Build unit tests " ON)
option(BUILD_UTILITIES "Build utilities tests " ON)
option(BUILD_EXAMPLES "Build examples tests " ON)
# If defined, this will modify the build environment to use General Electric's Libraries,
# which are needed to link against and use their SDK to open and process their raw data.
option(build4GE FALSE OFF)

# and include it to the search list
list(APPEND CMAKE_MODULE_PATH ${ISMRMRD_CMAKE_DIR})


# set the build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# compiler flags
if (WIN32)
    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS)
    add_definitions(-DUNICODE -D_UNICODE)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_STATIC_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_MODULE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    add_definitions(-D__func__=__FUNCTION__)
elseif (build4GE)
    message (STATUS, " Setting up ISMRMRD build to use GE SDK HDF5 and Boost components for GE converter.")
    if(DEFINED ENV{SDKTOP})
       cmake_policy (SET CMP0074 OLD)
       set(HDF5_ROOT                   "$ENV{SDKTOP}/3p")
       set(BOOST_ROOT                  "$ENV{SDKTOP}/3p")
    else ()
       message (FATAL_ERROR, " SDKTOP not defined - cannot configure ISMRMRD build for GE properly.")
    endif ()
    set(Boost_USE_STATIC_LIBS       "ON")
    set(Boost_NO_SYSTEM_PATHS       "TRUE")
    set(HDF5_USE_STATIC_LIBRARIES   "yes")
    set(CMAKE_C_FLAGS               "${CMAKE_C_FLAGS} -std=c99 -Wall")
    set(CMAKE_CXX_FLAGS             "${CMAKE_CXX_FLAGS} -w -std=c++11 -D_GLIBCXX_USE_CXX11_ABI=0")
else ()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11 -Werror")
endif ()

#  ---   VERSIONING  (begin) ----
#The ISMRMRD convention is to use version numbers with the format:
#   XX.YY.ZZ (major, minor, patch)
#
#The major number increments when the binary compatibility of
#the fixed memory layout struts (e.g. AcquisitionHeader) is broken.
#The minor number changes when there are changes to the XML schema for
#the flexible header. The micro number changes when there are small changes
#in the utility libraries, that don't affect the data format itself.
# For more information see http://semver.org/
set(ISMRMRD_VERSION_MAJOR 1)
set(ISMRMRD_VERSION_MINOR 8)
set(ISMRMRD_VERSION_PATCH 0)
set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})

set(ISMRMRD_XML_SCHEMA_SHA1 "5464ea590ded027471b0740bba7472c4919b895b")

#Remove line breaks and white space that does not change the meaning of the schema
file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file
string(REPLACE ";" "" SCHEMA_NO_BREAKS  ${SCHEMA_STRINGS}) #Concatenate the list of strings
string(REGEX REPLACE ">[ \t]+<" "><" SCHEMA_NO_SPACE ${SCHEMA_NO_BREAKS}) #Remove spaces and tabs
string(STRIP ${SCHEMA_NO_SPACE} SCHEMA_NO_SPACE) #Strip any leading/trailing whitespace
set(ISMRMRD_SCHEMA_DIR ${CMAKE_CURRENT_BINARY_DIR})
file(WRITE ${ISMRMRD_SCHEMA_DIR}/ismrmrd_no_white_space.xsd ${SCHEMA_NO_SPACE}) #Write to file

#Now hash the cleaned up file
file(SHA1 ${CMAKE_CURRENT_BINARY_DIR}/ismrmrd_no_white_space.xsd ISMRMRD_CURRENT_XML_SCHEMA_SHA1)

#Compare to last known hash
if (NOT (${ISMRMRD_XML_SCHEMA_SHA1} STREQUAL ${ISMRMRD_CURRENT_XML_SCHEMA_SHA1}))
  message("")
  message("-----------------------------------------------")
  message("            !!VERSION ERROR!!                  ")
  message("                                               ")
  message(" Expected SHA1 hash:                           ")
  message("    ${ISMRMRD_XML_SCHEMA_SHA1}")
  message(" Actual SHA1 hash:                             ")
  message("    ${ISMRMRD_CURRENT_XML_SCHEMA_SHA1}")
  message("                                               ")
  message(" The XML Schema (ismrmrmd.xsd) has changed and ")
  message(" the MINOR version number should be increased  ")
  message(" and the SHA1 has should be updated in the     ")
  message(" CMakelists.txt file.                          ")
  message("                                               ")
  message(" If you don't know what this message means, you")
  message(" probably shouldn't be changing anything       ")
  message("-----------------------------------------------")
  message("")
  message(FATAL_ERROR "     FATAL XML VERSION ERROR")
endif()


# Find HDF5 for dataset support


if (USE_HDF5_DATASET_SUPPORT)
    if (VCPKG_TARGET_TRIPLET) #VCPKG HDF5 is packaged differently.
        find_package(HDF5 CONFIG COMPONENTS C shared REQUIRED)
        set(HDF5_C_LIBRARIES hdf5::hdf5-shared)
    else ()
        find_package(HDF5 COMPONENTS C REQUIRED)
    endif ()
    set(ISMRMRD_DATASET_SUPPORT true)
    set(ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
    set(ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_INCLUDE_DIRS})
    set(ISMRMRD_DATASET_LIBRARIES ${HDF5_C_LIBRARIES})
    message(STATUS "HDF5 include found at: ${HDF5_INCLUDE_DIRS}")
    message(STATUS "HDF5 libs found at: ${HDF5_C_LIBRARIES}")

else ()
    set(ISMRMRD_DATASET_SUPPORT false)
    message(WARNING " Dataset and file support unavailable!")
endif ()

# Generate the version.h header file
find_package(Git)
if (GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD WORKING_DIRECTORY
            ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE ISMRMRD_GIT_SHA1 ERROR_VARIABLE ISMRMRD_GIT_STDERR)
    string(STRIP "${ISMRMRD_GIT_SHA1}" ISMRMRD_GIT_SHA1)
    string(LENGTH "${ISMRMRD_GIT_SHA1}" ISMRMRD_GIT_SHA1_LEN)
    if (${ISMRMRD_GIT_SHA1_LEN} LESS 40)
        message(WARNING "Could not determine SHA-1 hash: ${ISMRMRD_GIT_STDERR}")
        set(ISMRMRD_GIT_SHA1 "NA")
    endif ()
else()
  set(ISMRMRD_GIT_SHA1 "NA")
endif()
configure_file(include/version.in ${CMAKE_BINARY_DIR}/include/ismrmrd/version.h)
install(FILES ${CMAKE_BINARY_DIR}/include/ismrmrd/version.h DESTINATION include/ismrmrd COMPONENT Devel)
# note: for the utilities in this project that need ismrmrd/version.h
# remember to add ${CMAKE_BINARY_DIR}/include to the include path


#  ---   VERSIONING  (end) ----

#  ---   Main Library  (begin) ----
# in windows, install the HDF5 dependencies

# include directories for main library
set(ISMRMRD_TARGET_INCLUDE_DIRS
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>
  $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include>
  ${ISMRMRD_DATASET_INCLUDE_DIR}
)

set(ISMRMRD_TARGET_SOURCES
  libsrc/ismrmrd.c
  libsrc/ismrmrd.cpp
  libsrc/xml.cpp
  libsrc/meta.cpp
  libsrc/waveform.cpp
  libsrc/waveform.c
  ${ISMRMRD_DATASET_SOURCES}
)

set(ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_DATASET_LIBRARIES})

# optional handling of system-installed pugixml
if (USE_SYSTEM_PUGIXML)

    if (VCPKG_TARGET_TRIPLET) #VCPKG .
        find_package(PugiXML CONFIG REQUIRED)
        list(APPEND ISMRMRD_TARGET_LINK_LIBS pugixml)
    else ()
        find_package(PugiXML REQUIRED)

        message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
    endif ()
else ()
    list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
endif ()

if (build4GE)
   list(APPEND ISMRMRD_TARGET_LINK_LIBS pthread z dl)
endif ()

# main library
add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
target_include_directories(ismrmrd PUBLIC ${ISMRMRD_TARGET_INCLUDE_DIRS})
if (USE_HDF5_DATASET_SUPPORT)
  target_compile_options(ismrmrd PUBLIC ${HDF5_DEFINITIONS})
endif()
add_library(ismrmrd::ismrmrd ALIAS ismrmrd)
set_target_properties(ismrmrd PROPERTIES
  VERSION ${ISMRMRD_VERSION_STRING}
  SOVERSION ${ISMRMRD_SOVERSION}
)

set_target_properties(ismrmrd
  PROPERTIES
  EXPORT_NAME ISMRMRD)

target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})
list(APPEND ISMRMRD_LIBRARIES ismrmrd) # Add to list of libraries to be found
list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libraries

include(GNUInstallDirs)

# install the main library
install(TARGETS ismrmrd EXPORT ISMRMRDTargets
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} 
   COMPONENT Devel
)

# install the headers
install(DIRECTORY include/ismrmrd  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT Devel)

# install the schema file
install(FILES schema/ismrmrd.xsd DESTINATION share/ismrmrd/schema COMPONENT Devel)

#  ---   Main Library  (end) ----

# process subdirectories
add_subdirectory(doc)

if (BUILD_UTILITIES)
  add_subdirectory(utilities)
endif()


if (HDF5_FOUND AND BUILD_EXAMPLES)
    add_subdirectory(examples/c)
endif ()

# TODO: make this work on Windows
if (BUILD_TESTS)
   if (NOT build4GE)
      add_subdirectory(tests)
   endif ()
endif ()

# install the matlab api
install(DIRECTORY matlab DESTINATION share/ismrmrd )

#--- Create cmake package for downstream projects
#

include(CMakePackageConfigHelpers)
set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/ISMRMRD)

set(CONFIG_ISMRMRD_SCHEMA_DIR   ${ISMRMRD_SCHEMA_DIR})
set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${ISMRMRD_TARGET_INCLUDE_DIRS})
set(CONFIG_ISMRMRD_LIBRARY_DIRS ${ISMRMRD_LIBRARY_DIRS})
configure_file(cmake/ISMRMRDConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfig.cmake"
  @ONLY
)

set(CONFIG_ISMRMRD_SCHEMA_DIR   ${CMAKE_INSTALL_PREFIX}/share/ismrmrd/schema)
set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/include)
set(CONFIG_ISMRMRD_LIBRARY_DIRS ${CMAKE_INSTALL_PREFIX}/lib)
if (ISMRMRD_DATASET_SUPPORT)
  list(APPEND CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
endif ()

configure_package_config_file(cmake/ISMRMRDConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
  INSTALL_DESTINATION ${INSTALL_CONFIGDIR})

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
  VERSION ${ISMRMRD_VERSION_STRING}
  COMPATIBILITY SameMajorVersion
  )

# Write a CMake file with all the targets information
# (not for installing, but for external project to import targets from the
#  current build tree)
if(CMAKE_VERSION VERSION_LESS 3.0)
  export(TARGETS ismrmrd
    FILE ${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake
    NAMESPACE ISMRMRD::
    )
else()
  export(EXPORT ISMRMRDTargets

=== doc/requirements.txt ===
myst-parser
sphinx~=4.3.0
breathe
sphinx-rtd-theme
sphinxcontrib-mermaid

=== tests/CMakeLists.txt ===
find_package(Boost 1.43 COMPONENTS unit_test_framework)

if (NOT Boost_UNIT_TEST_FRAMEWORK_FOUND)
    message("Boost Unit Test Framework not found. Not compiling tests")
    return()
endif ()

if (NOT Boost_USE_STATIC_LIBS)
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif()

include_directories(${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include ${Boost_INCLUDE_DIR})

add_executable(test_ismrmrd
    test_main.cpp
    test_acquisitions.cpp
    test_images.cpp
    test_ndarray.cpp
    test_flags.cpp
    test_channels.cpp
    test_quaternions.cpp)

target_link_libraries(test_ismrmrd ismrmrd ${Boost_LIBRARIES})

add_custom_target(check COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_ismrmrd DEPENDS test_ismrmrd)

=== utilities/CMakeLists.txt ===
# Build the info application
message("Building info application")
include_directories(${CMAKE_BINARY_DIR}/include
                    ${CMAKE_SOURCE_DIR}/include
		    ${CMAKE_SOURCE_DIR}/libsrc)

add_executable(ismrmrd_info ismrmrd_info.cpp)
target_link_libraries(ismrmrd_info ismrmrd)
install(TARGETS ismrmrd_info DESTINATION bin)

if (NOT WIN32)
  add_executable(ismrmrd_test_xml
    ismrmrd_test_xml.cpp
    ${CMAKE_SOURCE_DIR}/libsrc/pugixml.cpp )
  target_link_libraries(ismrmrd_test_xml ismrmrd)
  install(TARGETS ismrmrd_test_xml DESTINATION bin)
endif()

if (HDF5_FOUND)
    add_executable(ismrmrd_read_timing_test read_timing_test.cpp)
    target_link_libraries(ismrmrd_read_timing_test ismrmrd)
    install(TARGETS ismrmrd_read_timing_test DESTINATION bin)

    find_package(Boost 1.43 COMPONENTS program_options random)
    if (WIN32)
        add_definitions(-DBOOST_ALL_NO_LIB)
        add_definitions(-DBOOST_ALL_DYN_LINK)
    endif()
    find_package(FFTW3 COMPONENTS single)

    if(FFTW3_FOUND AND Boost_FOUND)
        message("FFTW3 and Boost Found... building utilities")

        if(WIN32)
            link_directories(${Boost_LIBRARY_DIRS})
        endif()

        include_directories(
            ${CMAKE_SOURCE_DIR/include}
            ${Boost_INCLUDE_DIR}
            ${FFTW3_INCLUDE_DIR})

        # Shepp-Logan phantom
        add_executable(ismrmrd_generate_cartesian_shepp_logan
            generate_cartesian_shepp_logan.cpp
            ismrmrd_phantom.cpp)
        target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
            ismrmrd
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            ${FFTW3_LIBRARIES})
        
        install(TARGETS ismrmrd_generate_cartesian_shepp_logan DESTINATION bin)

        # Shepp-Logan phantom
        add_executable(ismrmrd_recon_cartesian_2d
            recon_cartesian_2d.cpp)
		target_link_libraries( ismrmrd_recon_cartesian_2d
            ismrmrd
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            ${FFTW3_LIBRARIES})

        install(TARGETS ismrmrd_recon_cartesian_2d DESTINATION bin)

    else()
        message("FFTW3 or Boost NOT Found, cannot build utilities")
    endif()
else ()
    message("HDF5 NOT Found, cannot build utilities")
endif ()

=== examples/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(ISMRMRD-C-EXAMPLE)

# if building this example as a standalone project
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    find_package(ISMRMRD REQUIRED)

# otherwise, building it as part of ISMRMRD itself
else()
    set(ISMRMRD_LIBRARIES ismrmrd)
endif()

# In previous ISMRMRD versions, we needed to use ISMRMRD_INCLUDE_DIR,
# but this is no longer necessary as the $(ISMRMRD_LIBRARIES} target
# has this as a property.
add_executable(ismrmrd_c_example main.c)
target_link_libraries(ismrmrd_c_example ${ISMRMRD_LIBRARIES})
install(TARGETS ismrmrd_c_example DESTINATION bin)

=== debian/changelog ===
ismrmrd (1.8.0-2build8) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:07:34 +0200

ismrmrd (1.8.0-2build7) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:57:12 +0200

ismrmrd (1.8.0-2build6) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Miriam España Acebal <miriam.espana@canonical.com>  Sun, 26 Jan 2025 10:57:24 +0000

ismrmrd (1.8.0-2build5) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 01:23:33 +0100

ismrmrd (1.8.0-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:25:52 +0000

ismrmrd (1.8.0-2build3) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:58:27 +0000

ismrmrd (1.8.0-2build2) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:50:45 +0100

ismrmrd (1.8.0-2build1) mantic; urgency=medium

  * No-change rebuild against glibc 2.38-1ubuntu2

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 11 Aug 2023 12:32:57 +0200

ismrmrd (1.8.0-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Mon, 02 May 2022 13:51:48 +0200

ismrmrd (1.8.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Bump SONAME again
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Andreas Tille <tille@debian.org>  Sun, 10 Apr 2022 20:44:57 +0200

ismrmrd (1.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * watch file standard 4 (routine-update)
  * Build-Depends: libboost-random-dev
  * Bump SONAME
  * debian/not-installed mentioning matlab files
  * review copyright

 -- Andreas Tille <tille@debian.org>  Mon, 21 Mar 2022 20:12:39 +0100

=== debian/control ===
Source: ismrmrd
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               d-shlibs,
               libboost-program-options-dev,
               libboost-random-dev,
               libboost-test-dev,
               libfftw3-dev,
               libhdf5-dev,
               libpugixml-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/ismrmrd
Vcs-Git: https://salsa.debian.org/med-team/ismrmrd.git
Homepage: https://ismrmrd.github.io/
Rules-Requires-Root: no

Package: libismrmrd1.8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libismrmrd1.3, libismrmrd1.4, libismrmrd1.7
Replaces: libismrmrd1.3, libismrmrd1.4, libismrmrd1.7
Description: ISMRM Raw Data format (ISMRMRD)
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the shared library.

Package: libismrmrd-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libhdf5-dev,
         libpugixml-dev,
         libismrmrd1.8 (= ${binary:Version})
Suggests: libismrmrd-doc
Description: development files for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the development files.

Package: libismrmrd-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the documentation.

Package: ismrmrd-tools
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ismrmrd-schema
Description: command-line tools for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the command-line tools.

Package: ismrmrd-schema
Architecture: all
Multi-Arch: foreign
Section: misc
Depends: ${misc:Depends}
Description: schema for ISMRMRD
 The ISMRMRD format combines a mix of flexible data structures (XML header)
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing
 reconstructed images and the accompanying C++ library provides a convenient
 way of writing such images into HDF5 files along with generic arrays for
 storing less well defined data structures, e.g. coil sensitivity maps or
 other calibration data.
 .
 This package provides the XML schema.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON

override_dh_auto_build-indep:
	dh_auto_build -- apidoc

override_dh_install-arch:
	find debian/tmp -name ismrmrd.xsd -delete
	dh_install -a
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/lib/*/cmake usr/lib/$(DEB_HOST_MULTIARCH) \
		    --movedev debian/tmp/usr/include usr \
		    debian/tmp/usr/lib/*/*.so
	find debian -name "lib*.la" -delete

override_dh_auto_install-indep:
	echo "No need to do install for architecture indep packages"

override_dh_auto_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress:
	dh_compress --exclude=examples

override_dh_missing-arch:
	find debian/tmp -type f  \( -name '*.m' -o -name 'ismrmrd_c_example' \) -delete
	dh_missing -a

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/ismrmrd-$1\.tar\.gz/ \
  https://github.com/ismrmrd/ismrmrd/tags .*/v?(\d\S*)\.tar\.gz

## ismrmrd 1.14.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.21)
 foreach(p
     CMP0025 # CMake 3.0 Compiler id for Apple Clang is now ``AppleClang``.
     CMP0042 # CMake 3.0 ``MACOSX_RPATH`` is enabled by default.
@@ -18,8 +18,8 @@
   "Location of CMake scripts")
 
 # command line options
-option(USE_SYSTEM_PUGIXML "Use pugixml installed on the system" OFF)
 option(USE_HDF5_DATASET_SUPPORT "Compile with support for reading and writing datasets to HDF5 files" ON)
+option(BUILD_STATIC "Build static library" OFF)
 option(BUILD_TESTS "Build unit tests " ON)
 option(BUILD_UTILITIES "Build utilities tests " ON)
 option(BUILD_EXAMPLES "Build examples tests " ON)
@@ -39,11 +39,23 @@
 endif()
 
 # compiler flags
+if(NOT "${CMAKE_CXX_STANDARD}")
+  set(CMAKE_CXX_STANDARD 11)
+else()
+  message(STATUS "CMAKE_CXX_STANDARD set externally to ${CMAKE_CXX_STANDARD}")
+endif()
+
+set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)
+
 if (WIN32)
-    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS)
+    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS -DBOOST_UUID_FORCE_AUTO_LINK)
     add_definitions(-DUNICODE -D_UNICODE)
     add_definitions(-D_CRT_SECURE_NO_WARNINGS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
+
+    # https://devblogs.microsoft.com/cppblog/msvc-now-correctly-reports-__cplusplus/
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
+
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
     set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
     set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
@@ -63,10 +75,10 @@
     set(Boost_NO_SYSTEM_PATHS       "TRUE")
     set(HDF5_USE_STATIC_LIBRARIES   "yes")
     set(CMAKE_C_FLAGS               "${CMAKE_C_FLAGS} -std=c99 -Wall")
-    set(CMAKE_CXX_FLAGS             "${CMAKE_CXX_FLAGS} -w -std=c++11 -D_GLIBCXX_USE_CXX11_ABI=0")
+    set(CMAKE_CXX_FLAGS             "${CMAKE_CXX_FLAGS} -w -D_GLIBCXX_USE_CXX11_ABI=0")
 else ()
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall -Werror")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++11 -Werror")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
 endif ()
 
 #  ---   VERSIONING  (begin) ----
@@ -80,12 +92,30 @@
 #in the utility libraries, that don't affect the data format itself.
 # For more information see http://semver.org/
 set(ISMRMRD_VERSION_MAJOR 1)
-set(ISMRMRD_VERSION_MINOR 8)
-set(ISMRMRD_VERSION_PATCH 0)
+set(ISMRMRD_VERSION_MINOR 14)
+set(ISMRMRD_VERSION_PATCH 3)
+
 set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
 set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})
 
-set(ISMRMRD_XML_SCHEMA_SHA1 "5464ea590ded027471b0740bba7472c4919b895b")
+if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
+file(READ ${CMAKE_CURRENT_SOURCE_DIR}/vcpkg.json VCPKG_JSON)
+string(JSON VCPKG_VERSION_STRING GET ${VCPKG_JSON} version)
+
+if (NOT VCPKG_VERSION_STRING STREQUAL ISMRMRD_VERSION_STRING)
+    message("")
+    message("-----------------------------------------------")
+    message("            !! VCPKG VERSION ERROR!!           ")
+    message(" Vcpkg version in vcpkg.json must match ISMRMRD")
+    message("           version in CMakeLists.txt           ")
+    message("-----------------------------------------------")
+    message("")
+    message(FATAL_ERROR "     FATAL VCPKG VERSION ERROR")
+endif ()
+
+endif()
+
+set(ISMRMRD_XML_SCHEMA_SHA1  "40036f175a77542b50acbcfb0f019094c90b5e18")
 
 #Remove line breaks and white space that does not change the meaning of the schema
 file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file
@@ -121,24 +151,37 @@
   message(FATAL_ERROR "     FATAL XML VERSION ERROR")
 endif()
 
+# Find static libraries only if linking statically
+if (BUILD_STATIC)
+    set(Boost_USE_STATIC_LIBS On)
+    set(HDF5_USE_STATIC_LIBRARIES TRUE)
+    set(FFTW_USE_STATIC_LIBS TRUE)
+else()
+    add_definitions(-DBOOST_TEST_DYN_LINK)
+endif()
+
+# Find Boost for tests and utilities
+find_package(Boost COMPONENTS filesystem random program_options unit_test_framework)
+find_package(pugixml CONFIG REQUIRED)
+find_package(FFTW COMPONENTS FLOAT_LIB)
 
 # Find HDF5 for dataset support
-
-
 if (USE_HDF5_DATASET_SUPPORT)
     if (VCPKG_TARGET_TRIPLET) #VCPKG HDF5 is packaged differently.
-        find_package(HDF5 CONFIG COMPONENTS C shared REQUIRED)
-        set(HDF5_C_LIBRARIES hdf5::hdf5-shared)
+        find_package(HDF5 CONFIG COMPONENTS C REQUIRED)
+        if (BUILD_STATIC)
+          set(ISMRMRD_DATASET_LIBRARIES hdf5::hdf5-static)
+        else()
+          set(ISMRMRD_DATASET_LIBRARIES hdf5::hdf5-shared)
+        endif()
     else ()
         find_package(HDF5 COMPONENTS C REQUIRED)
+        set(ISMRMRD_DATASET_LIBRARIES HDF5::HDF5)
     endif ()
     set(ISMRMRD_DATASET_SUPPORT true)
     set(ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
-    set(ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_INCLUDE_DIRS})
-    set(ISMRMRD_DATASET_LIBRARIES ${HDF5_C_LIBRARIES})
     message(STATUS "HDF5 include found at: ${HDF5_INCLUDE_DIRS}")
     message(STATUS "HDF5 libs found at: ${HDF5_C_LIBRARIES}")
-
 else ()
     set(ISMRMRD_DATASET_SUPPORT false)
     message(WARNING " Dataset and file support unavailable!")
@@ -163,11 +206,9 @@
 # note: for the utilities in this project that need ismrmrd/version.h
 # remember to add ${CMAKE_BINARY_DIR}/include to the include path
 
-
 #  ---   VERSIONING  (end) ----
 
 #  ---   Main Library  (begin) ----
-# in windows, install the HDF5 dependencies
 
 # include directories for main library
 set(ISMRMRD_TARGET_INCLUDE_DIRS
@@ -182,6 +223,7 @@
   libsrc/ismrmrd.cpp
   libsrc/xml.cpp
   libsrc/meta.cpp
+  libsrc/serialization.cpp
   libsrc/waveform.cpp
   libsrc/waveform.c
   ${ISMRMRD_DATASET_SOURCES}
@@ -189,46 +231,47 @@
 
 set(ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_DATASET_LIBRARIES})
 
-# optional handling of system-installed pugixml
-if (USE_SYSTEM_PUGIXML)
-
-    if (VCPKG_TARGET_TRIPLET) #VCPKG .
-        find_package(PugiXML CONFIG REQUIRED)
-        list(APPEND ISMRMRD_TARGET_LINK_LIBS pugixml)
-    else ()
-        find_package(PugiXML REQUIRED)
-
-        message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
-        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
-        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
-        list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
-        list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
-    endif ()
-else ()
-    list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
-endif ()
-
 if (build4GE)
    list(APPEND ISMRMRD_TARGET_LINK_LIBS pthread z dl)
 endif ()
 
+
 # main library
-add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
+if (BUILD_STATIC)
+  if (WIN32)
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
+  endif()
+  set(ISMRMRD_PUGIXML_LIBRARIES pugixml::static)
+  add_library(ismrmrd STATIC ${ISMRMRD_TARGET_SOURCES})
+else()
+  set(ISMRMRD_PUGIXML_LIBRARIES pugixml::shared)
+  add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
+endif()
+
+list(APPEND ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_PUGIXML_LIBRARIES})
+
 target_include_directories(ismrmrd PUBLIC ${ISMRMRD_TARGET_INCLUDE_DIRS})
 if (USE_HDF5_DATASET_SUPPORT)
   target_compile_options(ismrmrd PUBLIC ${HDF5_DEFINITIONS})
 endif()
+
 add_library(ismrmrd::ismrmrd ALIAS ismrmrd)
-set_target_properties(ismrmrd PROPERTIES
-  VERSION ${ISMRMRD_VERSION_STRING}
-  SOVERSION ${ISMRMRD_SOVERSION}
+
+target_compile_definitions(
+    ismrmrd
+    PUBLIC $<$<CONFIG:Debug>:ISMRMRD_DEBUG>
+    INTERFACE $<$<NOT:$<BOOL:${BUILD_STATIC}>>:ISMRMRD_IMPORT>
+    PRIVATE $<$<CXX_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS>
 )
 
 set_target_properties(ismrmrd
   PROPERTIES
-  EXPORT_NAME ISMRMRD)
-
-target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})
+  DEFINE_SYMBOL ISMRMRD_EXPORT
+  EXPORT_NAME ISMRMRD
+  VERSION ${ISMRMRD_VERSION_STRING}
+  SOVERSION ${ISMRMRD_SOVERSION})
+
+target_link_libraries(ismrmrd PUBLIC ${ISMRMRD_TARGET_LINK_LIBS})
 list(APPEND ISMRMRD_LIBRARIES ismrmrd) # Add to list of libraries to be found
 list(APPEND ISMRMRD_LIBRARY_DIRS ${CMAKE_BINARY_DIR} ) # Add to list of directories to find libraries
 
@@ -238,7 +281,7 @@
 install(TARGETS ismrmrd EXPORT ISMRMRDTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} 
+   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT Devel
 )
 
@@ -256,7 +299,6 @@
 if (BUILD_UTILITIES)
   add_subdirectory(utilities)
 endif()
-
 
 if (HDF5_FOUND AND BUILD_EXAMPLES)
     add_subdirectory(examples/c)
@@ -265,6 +307,7 @@
 # TODO: make this work on Windows
 if (BUILD_TESTS)
    if (NOT build4GE)
+       enable_testing()
       add_subdirectory(tests)
    endif ()
 endif ()
@@ -276,40 +319,3 @@
 #
 
 include(CMakePackageConfigHelpers)
-set(INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/ISMRMRD)
-
-set(CONFIG_ISMRMRD_SCHEMA_DIR   ${ISMRMRD_SCHEMA_DIR})
-set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${ISMRMRD_TARGET_INCLUDE_DIRS})
-set(CONFIG_ISMRMRD_LIBRARY_DIRS ${ISMRMRD_LIBRARY_DIRS})
-configure_file(cmake/ISMRMRDConfig.cmake.in
-  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfig.cmake"
-  @ONLY
-)
-
-set(CONFIG_ISMRMRD_SCHEMA_DIR   ${CMAKE_INSTALL_PREFIX}/share/ismrmrd/schema)
-set(CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${CMAKE_INSTALL_PREFIX}/include)
-set(CONFIG_ISMRMRD_LIBRARY_DIRS ${CMAKE_INSTALL_PREFIX}/lib)
-if (ISMRMRD_DATASET_SUPPORT)
-  list(APPEND CONFIG_ISMRMRD_TARGET_INCLUDE_DIRS ${HDF5_INCLUDE_DIRS})
-endif ()
-
-configure_package_config_file(cmake/ISMRMRDConfig.cmake.in
-  "${CMAKE_CURRENT_BINARY_DIR}/InstallFiles/ISMRMRDConfig.cmake"
-  INSTALL_DESTINATION ${INSTALL_CONFIGDIR})
-
-write_basic_package_version_file(
-  "${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDConfigVersion.cmake"
-  VERSION ${ISMRMRD_VERSION_STRING}
-  COMPATIBILITY SameMajorVersion
-  )
-
-# Write a CMake file with all the targets information
-# (not for installing, but for external project to import targets from the
-#  current build tree)
-if(CMAKE_VERSION VERSION_LESS 3.0)
-  export(TARGETS ismrmrd
-    FILE ${CMAKE_CURRENT_BINARY_DIR}/ISMRMRDTargets.cmake
-    NAMESPACE ISMRMRD::
-    )
-else()
-  export(EXPORT ISMRMRDTargets

=== doc/CMakeLists.txt ===
add_custom_target(doc)
find_package(Doxygen)
if(DOXYGEN_FOUND)
    set(API_DOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/html/api)
    set(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${DOXYFILE} @ONLY)

    add_custom_target(apidoc
        COMMAND ${CMAKE_COMMAND} -E make_directory ${API_DOC_DIR}
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
        COMMENT "Generating API documentation using Doxygen" VERBATIM)
    add_dependencies(doc apidoc)
else()
    message(STATUS "Doxygen not found. Not able to build API documentation")
endif()

=== doc/requirements.txt ===
myst-parser
sphinx==6.2.1
breathe
sphinx-rtd-theme
sphinxcontrib-mermaid

=== tests/CMakeLists.txt ===
if (NOT Boost_UNIT_TEST_FRAMEWORK_FOUND)
    message("Boost Unit Test Framework not found. Not compiling tests")
    return()
endif ()

file(READ ${CMAKE_SOURCE_DIR}/schema/ismrmrd_example.xml ismrmrd_example)
string(REPLACE "\"" "\\\"" ismrmrd_example ${ismrmrd_example})
string(REPLACE "\n" "\\\n" ismrmrd_example ${ismrmrd_example})

file(READ ${CMAKE_SOURCE_DIR}/schema/ismrmrd_example_extended.xml ismrmrd_example_extended)
string(REPLACE "\"" "\\\"" ismrmrd_example_extended ${ismrmrd_example_extended})
string(REPLACE "\n" "\\\n" ismrmrd_example_extended ${ismrmrd_example_extended})

configure_file(embedded_xml.h.in embedded_xml.h)

include_directories(${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include ${Boost_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

set(TEST_SOURCES
    test_main.cpp
    test_acquisitions.cpp
    test_images.cpp
    test_ndarray.cpp
    test_flags.cpp
    test_channels.cpp
    test_xml_header.cpp
    test_quaternions.cpp
    test_serialization.cpp)

if (USE_HDF5_DATASET_SUPPORT)
    set(TEST_SOURCES ${TEST_SOURCES}
        test_dataset.cpp
        test_end_to_end.cpp)

    add_executable(benchmark_dataset benchmark_dataset.cpp)
    target_link_libraries(benchmark_dataset ismrmrd ${Boost_LIBRARIES})
    set_property(TARGET benchmark_dataset PROPERTY CXX_STANDARD 11)
endif()

add_executable(test_ismrmrd ${TEST_SOURCES})
target_link_libraries(test_ismrmrd ismrmrd ${Boost_LIBRARIES})
add_test(NAME check COMMAND test_ismrmrd )

=== utilities/CMakeLists.txt ===
# Build the info application
message("Building info application")
include_directories(${CMAKE_BINARY_DIR}/include
                    ${CMAKE_SOURCE_DIR}/include
		    ${CMAKE_SOURCE_DIR}/libsrc)

add_executable(ismrmrd_info ismrmrd_info.cpp)
target_link_libraries(ismrmrd_info ismrmrd)
install(TARGETS ismrmrd_info DESTINATION bin)

add_executable(ismrmrd_test_xml ismrmrd_test_xml.cpp)
target_link_libraries(ismrmrd_test_xml ismrmrd)
install(TARGETS ismrmrd_test_xml DESTINATION bin)

if (HDF5_FOUND)
    add_executable(ismrmrd_read_timing_test read_timing_test.cpp)
    target_link_libraries(ismrmrd_read_timing_test ismrmrd ${HDF5_C_LIBRARIES})
    install(TARGETS ismrmrd_read_timing_test DESTINATION bin)

    if(FFTW_FOUND AND Boost_FOUND)
        message("FFTW3 and Boost Found... building utilities")

        if(WIN32)
            link_directories(${Boost_LIBRARY_DIRS})
        endif()

        include_directories(
            ${CMAKE_SOURCE_DIR/include}
            ${Boost_INCLUDE_DIR}
            ${FFTW_INCLUDE_DIRS})

        # Shepp-Logan phantom
        add_executable(ismrmrd_generate_cartesian_shepp_logan
            generate_cartesian_shepp_logan.cpp
            ismrmrd_phantom.cpp)
        target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
            ismrmrd
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            ${FFTW_LIBRARIES})
        install(TARGETS ismrmrd_generate_cartesian_shepp_logan DESTINATION bin)

        # Shepp-Logan phantom
        add_executable(ismrmrd_recon_cartesian_2d
            recon_cartesian_2d.cpp)
		target_link_libraries( ismrmrd_recon_cartesian_2d
            ismrmrd
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            ${FFTW_LIBRARIES})
        install(TARGETS ismrmrd_recon_cartesian_2d DESTINATION bin)

        add_executable(ismrmrd_hdf5_to_stream ismrmrd_hdf5_to_stream.cpp)
        target_link_libraries(ismrmrd_hdf5_to_stream ismrmrd ${Boost_PROGRAM_OPTIONS_LIBRARY})
        install(TARGETS ismrmrd_hdf5_to_stream DESTINATION bin)

        add_executable(ismrmrd_stream_to_hdf5 ismrmrd_stream_to_hdf5.cpp)
        target_link_libraries(ismrmrd_stream_to_hdf5 ismrmrd ${Boost_PROGRAM_OPTIONS_LIBRARY})
        install(TARGETS ismrmrd_stream_to_hdf5 DESTINATION bin)

        add_executable(ismrmrd_stream_recon_cartesian_2d stream_recon_cartesian_2d.cpp)
        target_link_libraries(ismrmrd_stream_recon_cartesian_2d ismrmrd ${FFTW_LIBRARIES} ${Boost_PROGRAM_OPTIONS_LIBRARY})
        install(TARGETS ismrmrd_stream_recon_cartesian_2d DESTINATION bin)
    else()
        message("FFTW3 or Boost NOT Found, cannot build utilities")
    endif()
else ()
    message("HDF5 NOT Found, cannot build utilities")
endif ()

=== examples/c/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.21)
 project(ISMRMRD-C-EXAMPLE)
 
 # if building this example as a standalone project

=== debian/changelog ===
ismrmrd (1.14.3-1) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113055
  * d/watch: version=5
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Build-Depends: libboost-filesystem-dev
  * Soname bump to 1.14
  * Install all binaries
  * d/copyright: review
  * Lintian-overrides: update

 -- Andreas Tille <tille@debian.org>  Sat, 18 Oct 2025 16:35:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,33 +1,41 @@
 Source: ismrmrd
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
+Standards-Version: 4.7.2
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders:
+ Ghislain Antony Vaillant <ghisvail@gmail.com>,
 Section: science
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13),
-               d-shlibs,
-               libboost-program-options-dev,
-               libboost-random-dev,
-               libboost-test-dev,
-               libfftw3-dev,
-               libhdf5-dev,
-               libpugixml-dev
-Build-Depends-Indep: doxygen
-Standards-Version: 4.6.0
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ d-shlibs,
+ libboost-filesystem-dev,
+ libboost-program-options-dev,
+ libboost-random-dev,
+ libboost-test-dev,
+ libfftw3-dev,
+ libhdf5-dev,
+ libpugixml-dev,
+Build-Depends-Indep:
+ doxygen,
 Vcs-Browser: https://salsa.debian.org/med-team/ismrmrd
 Vcs-Git: https://salsa.debian.org/med-team/ismrmrd.git
 Homepage: https://ismrmrd.github.io/
 Rules-Requires-Root: no
 
-Package: libismrmrd1.8
+Package: libismrmrd1.14
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
-Breaks: libismrmrd1.3, libismrmrd1.4, libismrmrd1.7
-Replaces: libismrmrd1.3, libismrmrd1.4, libismrmrd1.7
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Breaks:
+ libismrmrd1.7,
+ libismrmrd1.8,
+Replaces:
+ libismrmrd1.7,
+ libismrmrd1.8,
 Description: ISMRM Raw Data format (ISMRMRD)
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -43,11 +51,13 @@
 Package: libismrmrd-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends},
-         libhdf5-dev,
-         libpugixml-dev,
-         libismrmrd1.8 (= ${binary:Version})
-Suggests: libismrmrd-doc
+Depends:
+ ${misc:Depends},
+ libhdf5-dev,
+ libpugixml-dev,
+ libismrmrd1.14 (= ${binary:Version}),
+Suggests:
+ libismrmrd-doc,
 Description: development files for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -64,7 +74,8 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: documentation for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -81,9 +92,10 @@
 Architecture: any
 Multi-Arch: foreign
 Section: utils
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         ismrmrd-schema
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+ ismrmrd-schema,
 Description: command-line tools for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.
@@ -100,7 +112,8 @@
 Architecture: all
 Multi-Arch: foreign
 Section: misc
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: schema for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header)
  and fixed structures (equivalent to C-structs) to represent MRI data.

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+
+export LC_ALL=en_US.UTF-8
 
 # Hardening flags.
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -13,7 +15,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON
+	dh_auto_configure -- -DUSE_SYSTEM_PUGIXML=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
 override_dh_auto_build-indep:
 	dh_auto_build -- apidoc

=== debian/tests/control ===
Test-Command: cd $AUTOPKGTEST_TMP
 ; cmake /usr/share/doc/libismrmrd-dev/examples/c/
 ; make -j$(nproc)
 ; ./ismrmrd_c_example
Depends: @, cmake, g++ | c++-compiler
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Template: Github
Owner: ismrmrd
Project: ismrmrd
